> ## Documentation Index
> Fetch the complete documentation index at: https://goldrush.dev/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Get token balances for address

> Commonly used to fetch the native and fungible (ERC20) tokens held by an address. Response includes spot prices and other metadata.

<CardGroup cols={2}>
  <Card title="Credit Cost"> 1 per call</Card>
  <Card title="Processing"> Realtime</Card>
</CardGroup>

<Tip>
  Estimate your monthly cost for this API using the [Pricing Calculator](/pricing-calculator?endpoint=%2Fapi-reference%2Ffoundational-api%2Fbalances%2Fget-token-balances-for-address).
</Tip>

<Info>
  Rebasing tokens (e.g. stETH, aTokens, cTokens) are supported on <a href="https://goldrush.dev/docs/chains/overview#foundational-chains" target="_blank" rel="noopener noreferrer">Foundational Chains</a>.
</Info>

<Accordion title="Related guides">
  <CardGroup cols={3}>
    <Card href="https://goldrush.dev/guides/understanding-web3-wallets">
      Understanding Web3 Wallets with GoldRush
    </Card>

    <Card href="https://goldrush.dev/guides/how-to-get-bitcoin-balances-and-transactions">
      How to Get Bitcoin Balances and Transactions
    </Card>

    <Card href="https://goldrush.dev/guides/comparing-covalent-token-balances-to-rpc">
      Comparing GoldRush’s Token Balances API to RPC Providers
    </Card>
  </CardGroup>
</Accordion>


## OpenAPI

````yaml GET /v1/{chainName}/address/{walletAddress}/balances_v2/
openapi: 3.1.0
info:
  title: GoldRush Multichain Data APIs
  version: 1.0.0
  description: Covalent's GoldRush Multichain Data APIs OpenAPI Schema.
servers:
  - url: https://api.covalenthq.com
security:
  - bearerAuth: []
paths:
  /v1/{chainName}/address/{walletAddress}/balances_v2/:
    get:
      tags:
        - get-token-balances-for-address
      description: >-
        Commonly used to fetch the native and fungible (ERC20) tokens held by an
        address. Response includes spot prices and other metadata.
      operationId: getTokenBalancesForWalletAddress
      parameters:
        - name: chainName
          in: path
          description: 'The chain name eg: `eth-mainnet`.'
          required: true
          schema:
            type: string
        - name: walletAddress
          in: path
          description: >-
            The requested address. Passing in an `ENS`, `RNS`, `Lens Handle`, or
            an `Unstoppable Domain` resolves automatically.
          required: true
          schema:
            type: string
        - name: quote-currency
          in: query
          description: >-
            The currency to convert. Supports `USD`, `CAD`, `EUR`, `SGD`, `INR`,
            `JPY`, `VND`, `CNY`, `KRW`, `RUB`, `TRY`, `NGN`, `ARS`, `AUD`,
            `CHF`, and `GBP`.
          required: false
          schema:
            type: string
        - name: no-spam
          in: query
          description: >-
            If `true`, the suspected spam tokens are removed. Supported on all
            Foundational Chains.
          required: false
          schema:
            type: boolean
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                type: object
                properties:
                  address:
                    type: string
                    description: The requested address.
                  chain_id:
                    type: integer
                    description: 'The requested chain ID eg: `1`.'
                  chain_name:
                    type: string
                    description: 'The requested chain name eg: `eth-mainnet`.'
                  chain_tip_height:
                    type: integer
                    description: >-
                      The latest block height of the blockchain at the time this
                      response was provided.
                  chain_tip_signed_at:
                    type: string
                    format: date-time
                    description: >-
                      The timestamp of the latest signed block at the time this
                      response was provided.
                  quote_currency:
                    type: string
                    description: 'The requested quote currency eg: `USD`.'
                  updated_at:
                    type: string
                    format: date-time
                    description: >-
                      The timestamp when the response was generated. Useful to
                      show data staleness to users.
                  items:
                    type: array
                    items:
                      type: object
                      properties:
                        contract_decimals:
                          type: integer
                          description: >-
                            Use contract decimals to format the token balance
                            for display purposes - divide the balance by
                            `10^{contract_decimals}`.
                        contract_name:
                          type: string
                          description: The string returned by the `name()` method.
                        contract_ticker_symbol:
                          type: string
                          description: >-
                            The ticker symbol for this contract. This field is
                            set by a developer and non-unique across a network.
                        contract_address:
                          type: string
                          description: >-
                            Use the relevant `contract_address` to lookup
                            prices, logos, token transfers, etc.
                        contract_display_name:
                          type: string
                          description: A display-friendly name for the contract.
                        supports_erc:
                          type: array
                          items:
                            type: string
                          description: >-
                            A list of supported standard ERC interfaces, eg:
                            `ERC20` and `ERC721`.
                        logo_urls:
                          type: object
                          properties:
                            token_logo_url:
                              type: string
                              description: The token logo URL.
                            protocol_logo_url:
                              type: string
                              description: The protocol logo URL.
                            chain_logo_url:
                              type: string
                              description: The chain logo URL.
                          description: The contract logo URLs.
                        last_transferred_at:
                          type: string
                          format: date-time
                          description: The timestamp when the token was transferred.
                        block_height:
                          type: integer
                          format: int64
                          description: The height of the block.
                        is_native_token:
                          type: boolean
                          description: >-
                            Indicates if a token is the chain's native gas
                            token, eg: ETH on Ethereum.
                        type:
                          type: string
                          description: >-
                            One of `cryptocurrency`, `stablecoin`, `nft` or
                            `dust`.
                        is_spam:
                          type: boolean
                          description: Denotes whether the token is suspected spam.
                        balance:
                          type: string
                          description: >-
                            b;The asset balance. Use `contract_decimals` to
                            scale this balance for display purposes.
                        balance_24h:
                          type: string
                          description: >-
                            b;The 24h asset balance. Use `contract_decimals` to
                            scale this balance for display purposes.
                        quote_rate:
                          type: number
                          format: double
                          description: The exchange rate for the requested quote currency.
                        quote_rate_24h:
                          type: number
                          format: double
                          description: >-
                            The 24h exchange rate for the requested quote
                            currency.
                        quote:
                          type: number
                          format: double
                          description: >-
                            The current balance converted to fiat in
                            `quote-currency`.
                        quote_24h:
                          type: number
                          format: double
                          description: >-
                            The 24h balance converted to fiat in
                            `quote-currency`.
                        pretty_quote:
                          type: string
                          description: >-
                            A prettier version of the quote for rendering
                            purposes.
                        pretty_quote_24h:
                          type: string
                          description: >-
                            A prettier version of the 24h quote for rendering
                            purposes.
                    description: List of response items.
      x-codeSamples:
        - lang: TypeScript
          label: GoldRush SDK
          source: |-
            import { GoldRushClient } from "@covalenthq/client-sdk";

            const ApiServices = async () => {
                const client = new GoldRushClient("<GOLDRUSH_API_KEY>");
                const resp = await client.BalanceService.getTokenBalancesForWalletAddress({chainName: "chainName", walletAddress: "walletAddress"});
                console.log(resp.data);
            };

            ApiServices();
components:
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      description: >-
        Bearer authentication header of the form: `Bearer <token>`, where
        `<token>` is your GoldRush API Key.

````